<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.6                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

function search(){

    $inCore = cmsCore::getInstance();
    $inPage = cmsPage::getInstance();
    $inDB   = cmsDatabase::getInstance();

    global $_LANG;

    $model = cms_model_search::initModel();

    $do = $inCore->do;

    $pagetitle = $inCore->getComponentTitle();

	$inPage->setTitle($pagetitle);
    $inPage->addPathway($pagetitle, '/search');

/* ==================================================================================================== */
/* ==================================================================================================== */
	if ($do == 'view'){

		if (mb_strlen($model->query)<=3 && mb_strlen($model->query)>=1){
			cmsCore::addSessionMessage($_LANG['ERROR'].': '.$_LANG['SHORT_QUERY'], 'error');
			$inCore->redirect('/search');
		}

		if($model->query){

			$inPage->addPathway($model->query);

			// если параметры запроса изменились
			// делаем полный поиск, заполняя кеш
			// иначе берем из кеша результаты
			if(!$model->isChangedParams()){

				// Удаляем записи поиска от текущей сессии
				$model->deleteResultsFromThisSession();

				// Готовим поиск
				// выполняется поиск по индексу фултекст
				if(!$model->prepareSearch()) { cmsCore::error404(); }

				// Кладем в сессию текущие параметры запроса
				cmsUser::sessionPut('query_params', $model->parametrs_array);
				// кладем в сессию слова запроса
				cmsUser::sessionPut('searchquery', $model->words);

			}

			// формируем условия выборки
			$model->whereSessionIs(session_id());
			$model->wherePeriodIs();
    		$inDB->orderBy('pubdate', ($model->order_by_date ? 'DESC' : 'ASC'));

			// Получаем общее количество результатов
			$total = $model->getCountResults();

			// Получаем сами результаты поиска
			if($total){
				$results = $model->getResults();
			}

		}

		cmsPage::initTemplate('components', 'com_search_text')->
                assign('query', $model->query)->
                assign('look', $model->look)->
                assign('order_by_date', $model->order_by_date)->
                assign('from_pubdate', $model->from_pubdate)->
                assign('results', $results)->
                assign('total', $total)->
                assign('enable_components', $model->getEnableComponentsWithSupportSearch())->
                assign('from_component', $model->from_component)->
                assign('external_link', str_replace('%q%', urlencode($model->query), $_LANG['FIND_EXTERNAL_URL']))->
                assign('host', HOST)->
                assign('res_count', (($model->page-1)*$model->config['perpage']+1))->
                assign('pagebar', cmsPage::getPagebar($total, $model->page, $model->config['perpage'], 'javascript:paginator(%page%)'))->
                display('com_search_text.tpl');

	}

/* ==================================================================================================== */
/* ==================================================================================================== */
	if ($do == 'tag'){

		if (mb_strlen($model->query)<=3 && mb_strlen($model->query)>=1){
			cmsCore::addSessionMessage($_LANG['EMPTY_QUERY'], 'error');
			$inCore->redirect('/search');
		}

		$inPage->setTitle($_LANG['SEARCH_BY_TAG'].' "'.$model->query.'"');

		if($model->query){
			$inPage->addPathway($_LANG['SEARCH_BY_TAG'].' "'.$model->query.'"');
		}
		$inPage->initAutocomplete();

		$total   = $model->getCountTags();

		$results = $model->searchByTag();
		
/* seo tags */	

foreach ($results as $st){//собираем все теги
    $alltag .= strip_tags($st['tag_bar']);
    $alltag .= ',';
    }
    
    $masstag = explode(',', $alltag);
    $masstag = array_unique($masstag);
    
    foreach ($masstag as $st){//сортируем по порядку
        $st = trim($st);
    if ($st != $model->query){
        $tagv = $inDB->get_fields('cms_tags', "tag='{$st}'", '*');
        if ($tagv['chec'] == 1){
        $tag_ob[]=$st;}
    }}
        
        krsort($results);

if (!function_exists('mb_ucfirst') && extension_loaded('mbstring')){
	function mb_ucfirst($str, $encoding='UTF-8'){
		$str = mb_ereg_replace('^[\ ]+', '', $str);
		$str = mb_strtoupper(mb_substr($str, 0, 1, $encoding), $encoding).
			   mb_substr($str, 1, mb_strlen($str), $encoding);
		return $str;
	}}

$seost = $model->query;//текущий тэг
$seotagv = $inDB->get_fields('cms_tags', "tag='{$seost}'", '*');//все поля текущего тэга

$sql = "SELECT * FROM cms_seotag WHERE ist = 'line'"; //массив Seo тегов   
$result = $inDB->query($sql);
$seoline = $inDB->fetch_assoc($result);
$seoline = explode(", ", $seoline['colnum']);

$sql = "SELECT * FROM cms_seotag WHERE ist = '$seost'"; //массив Seo тегов   
$result = $inDB->query($sql);
$seot = $inDB->fetch_assoc($result);

if ($seot){
    $str = $seotagv['tag'];//текущий тэг
    $n = $seotagv['numline'] ;// № группы тэга
    $strs = $seoline[$n]; // название группы тэга
}else{
    $str = $seotagv['tag'];//текущий тэг
    $n = $seotagv['numline'] ;
    $strs = $seoline[$n];
$sql = "SELECT * FROM cms_seotag WHERE ist = '$strs'"; //массив Seo тегов 
$result = $inDB->query($sql);
$seot = $inDB->fetch_assoc($result);  
if (!$seot){
    $sql = "SELECT * FROM cms_seotag WHERE ist = 'all'"; //массив Seo тегов   
    $result = $inDB->query($sql);
    $seot = $inDB->fetch_assoc($result);
}}

 $seotitle = $seot['title'];// тайтл тэга
    $modtitle = str_replace("%tag%", mb_strtolower($str), $seotitle);
    $modtitle = str_replace("%Tag%", mb_ucfirst($str), $modtitle);
    $modtitle = str_replace('%cat%', mb_strtolower($strs), $modtitle);
    $modtitle = str_replace("%Cat%", mb_ucfirst($strs), $modtitle);
$inPage->setTitle($modtitle);

$seotitle = $seot['keywords'];// тайтл тэга
    $modtitle = str_replace("%tag%", mb_strtolower($str), $seotitle);
    $modtitle = str_replace("%Tag%", mb_ucfirst($str), $modtitle);
    $modtitle = str_replace('%cat%', mb_strtolower($strs), $modtitle);
    $modtitle = str_replace("%Cat%", mb_ucfirst($strs), $modtitle);
$inPage->setKeywords($modtitle);

$seotitle = $seot['description'];// тайтл тэга
    $modtitle = str_replace("%tag%", mb_strtolower($str), $seotitle);
    $modtitle = str_replace("%Tag%", mb_ucfirst($str), $modtitle);
    $modtitle = str_replace('%cat%', mb_strtolower($strs), $modtitle);
    $modtitle = str_replace("%Cat%", mb_ucfirst($strs), $modtitle);   
$inPage->setDescription($modtitle);
	
/* seo tags */		

		cmsPage::initTemplate('components', 'com_search_tag')->
                assign('query', $model->query)->
                assign('results', $results)->
                assign('total', $total)->
                assign('autocomplete_js', $inPage->getAutocompleteJS('tagsearch', 'query', false))->
                assign('external_link', '/index.php?view=search&query='.urlencode($model->query).'&look=allwords')->
                assign('pagebar', cmsPage::getPagebar($total, $model->page, $model->config['perpage'], '/search/tag/'.urlencode($model->query).'/page%page%.html'))->
                display('com_search_tag.tpl');
	}
	

	return true;

}
